<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" 
				xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
				xmlns:xalan="http://xml.apache.org/xalan"
				xmlns:dyn="http://exslt.org/dynamic"
				exclude-result-prefixes="xalan dyn">
	
	<xsl:output encoding="UTF-8" method="xml" indent="yes" />
	
	<!-- # Création du ant de reconstruction de la db -->	
	
	<xsl:template match="/sequence">
		<rolesMapping>
			<xsl:comment>
Actions :
- 	[renameRole from="-oldName-" to="-newName-"]
		[restrictOnScope level="{user|group|wsp|space}"/] ?
	[/renameRole]
- 	[addRole name="-newName-" type="allow|deny"]
		[onlyIfNoRole type="allow|deny"/] ?
		[restrictOnScope level="{user|group}"/] ?
	[/addRole]

@to : 
	- liste de rôle(s) séparé(s) par un espace
	- si vide, alors le rôle est supprimé


			</xsl:comment>
			<!-- # scope user -->
			<xsl:for-each select="xalan:distinct(importUsers/createOrUpdate/a/o[s[@k='userType']='user']/a[contains(@k, 'Roles')]/s)">
				<renameRole to="" from="{.}">
					<restrictOnScope level="user"/>
				</renameRole>
			</xsl:for-each>
			<!-- # scope group -->
			<xsl:for-each select="xalan:distinct(importUsers/createOrUpdate/a/o[s[@k='userType']='group']/a[contains(@k, 'Roles')]/s)">
				<renameRole to="" from="{.}">
					<restrictOnScope level="group"/>
				</renameRole>
			</xsl:for-each>
			<!-- # scope wsp -->
			<xsl:for-each select="xalan:distinct(dyn:map(createWsp/specifyRoles/*[contains(local-name(), 'Roles')]/@roles, 'xalan:tokenize(.)'))">
				<renameRole to="" from="{.}">
					<restrictOnScope level="wsp"/>
				</renameRole>
			</xsl:for-each>
			<!-- # scope space -->
			<xsl:for-each select="xalan:distinct(dyn:map(createWsp/createSrcNode/specifyRoles/*[contains(local-name(), 'Roles')]/@roles, 'xalan:tokenize(.)'))">
				<renameRole to="" from="{.}">
					<restrictOnScope level="space"/>
				</renameRole>
			</xsl:for-each>
		</rolesMapping>
	</xsl:template>
	
</xsl:stylesheet>